package com.example.felica;

import com.felicanetworks.mfc.AppInfo;
import com.felicanetworks.mfc.Felica;
import com.felicanetworks.mfc.FelicaEventListener;
import com.felicanetworks.mfc.FelicaException;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.IBinder;

public class FelicaConnection {

    private volatile Felica mFelica;
    private volatile boolean mIsFinishedActivateFelica;
    private Context mContext;
    private boolean mIsFelicaActivated;

    // Felica(Service)ڑǗpR[obN
    private ServiceConnection mServiceConnection =
            new ServiceConnection() {

        // Felica̐ڑʒm
        @Override
        public void onServiceConnected(ComponentName name,
                IBinder service) {
            synchronized (this) {
                mFelica = ((Felica.LocalBinder)service).getInstance();
            }
        }

        // Felica̐ؒfʒm
        @Override
        public void onServiceDisconnected(ComponentName name) {
            synchronized (this) {
                mFelica = null;
            }
        }
    };

    public FelicaConnection(Context context) {
        if (context == null) {
            throw new IllegalArgumentException();
        }
        mContext = context;
    }

    // Felicaւ̐ڑ𓯊IɎs
    public Felica connect() throws Exception {
        if (mFelica == null) {
            Intent intent = new Intent(mContext, Felica.class);
            // Felicaւ̐ڑv
            if (!mContext.bindService(intent, mServiceConnection,
                    Context.BIND_AUTO_CREATE)) {
                throw new Exception();
            }
            // Felicaւ̐ڑ҂
            while (mFelica == null) {
                try {
                    Thread.sleep(100);
                } catch (InterruptedException e) {
                    // ȗ
                }
            }
            try {
                // Felica̗pJnsi񓯊Ŏsj
                mFelica.activateFelica(null,
                        new FelicaEventListener() {

                            // pJnƂɌĂ΂
                            @Override
                            public void finished() {
                                mIsFelicaActivated = true;
                                mIsFinishedActivateFelica = true;
                            }

                            // pJnsƂɌĂ΂
                            @Override
                            public void errorOccurred(int id,
                                    String msg, AppInfo otherAppInfo) {
                                mIsFelicaActivated = false;
                                mIsFinishedActivateFelica = true;
                            }
                        });
            } catch (FelicaException e) {
                throw new Exception();
            }
            // pJn̏Iҋ@
            while (!mIsFinishedActivateFelica) {
                try {
                    Thread.sleep(100);
                } catch (InterruptedException e) {
                    // ȗ
                }
            }
            // pJnɎsꍇ͗O𓊂
            if (!mIsFelicaActivated) {
                throw new Exception();
            }
            try {
                // Felica`bvI[v
                mFelica.open();
            } catch (FelicaException e) {
                throw new Exception();
            }
        }
        return mFelica;
    }

    // FelicaƂ̐ڑؒf
    public void disconnect() {
        if (mFelica != null) {
            try {
                // Felica`bvN[Y
                mFelica.close();
                // Felica̗pI
                mFelica.inactivateFelica();
            } catch (FelicaException e) {
                // ȗ
            }
            mContext.unbindService(mServiceConnection);
        }
    }
}
