package com.example.push;

import android.content.Context;
import android.content.Intent;

import com.example.felica.FelicaConnection;
import com.felicanetworks.mfc.Felica;
import com.felicanetworks.mfc.PushIntentSegment;


public class PushPort {
    
    public interface Listener {
        public void onSendingStarted();
        public void onSendingSucceed();
        public void onSendingFailed();
    }
    
    public static void send(final Context context,
            final Intent intent, final Listener listener) {
        new Thread(new Runnable() {
            public void run() {
                FelicaConnection felicaConnection =
                        new FelicaConnection(context);
                try {
                    // FelicaƐڑ
                    Felica felica = felicaConnection.connect();
                    
                    // MIntent܂PushZOg̍쐬
                    PushIntentSegment pushSegment =
                            new PushIntentSegment(intent);

                    listener.onSendingStarted();
                    
                    // PushM
                    felica.push(pushSegment);
                    listener.onSendingSucceed();
                } catch (Exception e) {
                    listener.onSendingFailed();
                } finally {
                    // FelicaƐؒf
                    felicaConnection.disconnect();
                }

            } 
        }).start();
    }

}
