package com.example.pushMessageSendingApp;

import com.example.push.PushPort;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class PushMessageSendingAppInitiatorActivity extends Activity {

    // Handlerp̃bZ[W萔
    private static final int SHOW_MESSAGE = 0;

    // Target̋NΏۂƂȂActivity
    private static final String TARGET_ACTIVITY_NAME =
            ".PushMessageSendingAppTargetActivity";

    // M{^
    private Button mSendButton;
    // MbZ[W͗
    private EditText mSendMessageEditText;

    // UIpHandler
    private final Handler mHandler = new Handler() {

        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case SHOW_MESSAGE:
                    Toast.makeText(getApplicationContext(),
                            (String)msg.obj, Toast.LENGTH_SHORT)
                            .show();
                    break;
                default:
                    super.handleMessage(msg);
                    break;
            }
        }
    };

    private void showMessage(String message) {
        mHandler.sendMessage(mHandler.obtainMessage(
                SHOW_MESSAGE, message));
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.initiator);
        
        mSendMessageEditText = (EditText)findViewById(R.id.sendMessageEditText);
        mSendButton = (Button)findViewById(R.id.sendButton);
        mSendButton.setOnClickListener(new OnClickListener() {
            
            @Override
            public void onClick(View clickedView) {
                
                // MIntent쐬
                Intent intent = new Intent();
                // NTargetActivitỹR|[lgw肷
                intent.setClassName(getPackageName(),
                        getPackageName() + TARGET_ACTIVITY_NAME);
                // bZ[WIntentɊi[
                intent.putExtra(getResources().getString(
                        R.string.pushIntentExtraDataTag),
                        mSendMessageEditText.getText().toString());
                
                // PushM
                PushPort.send(getApplicationContext(),
                        intent,
                        new PushPort.Listener() {
                            
                            @Override
                            public void onSendingSucceed() {
                                // MbZ[WToast\
                                showMessage("M܂");
                            }
                            
                            @Override
                            public void onSendingStarted() {
                                // MJnbZ[WToast\
                                showMessage("MJn܂");
                            }
                            
                            @Override
                            public void onSendingFailed() {
                                // MsbZ[WToast\
                                showMessage("MɎs܂");   
                            }
                        });
            }
        });
    }
}